#! /usr/bin/perl -w
use strict;
use LWP::UserAgent;
use HTTP::Request::Common qw(POST);
# --------------------------------------------------------------------------------
# Script to extract weekly produced energy from: http://192.168.xxx.xxx/appliances/interval_logs
#
# Usage:  parseappliances.pl xmlfile
# --------------------------------------------------------------------------------
#	this is really ugly,
#	Synology people: please fix perl XML libraries in DSM 4.1!!!
BEGIN {
  require XML::Parser::Expat;
    my $saved_version=$XML::Parser::Expat::VERSION;
      $XML::Parser::Expat::VERSION= '2.36';
        require XML::Parser;
          $XML::Parser::Expat::VERSION= $saved_version;
          }
#           use XML::Parser;
           use LWP::Simple;

# --------------------------------------------------------------------------------------------
#  read command line parameters
my $xmlfile       = $ARGV[0];                    		# the file to parse
my $outfile_hours = $ARGV[1];                    		# the file to build 
my $outfile_days  = $ARGV[2];                    		# the file to build 
my $device_name   = $ARGV[3];                    		# name of device to read
my $pvlog_enabled = $ARGV[4];                           # will PVoutput be updated ?
my $PV_API_key    = $ARGV[5];                    		# API-key for PVoutput
my $PV_sid		  = $ARGV[6];                    		# sid for PVoutput
# --------------------------------------------------------------------------------------------

#start of script
# initialize parser object and parse the string
	my ( $periodend, $producedfound,@data,$log_date,$current_key,$tree,@new);
	my ($last_written, $last_written_date, $dayoutput);
	my (@pvlog, $url, $content, $pvurl,$separator);
	my $parser = XML::Parser->new();
	$separator=',';
	$periodend=0;
	$producedfound=0;
	$parser->setHandlers( Start => \&handle_start,
				  Char  => \&handle_char,
				  End   => \&handle_end,     );
																				 

	# Parse the file, calling the handlers in the mean time.
	$tree  = $parser->parsefile( $xmlfile );
    exit;

# end of script
# --------------------------------------------------------------------------------------------
# below the subs
#----------------------------------------------------------------
sub getpvlog
#----------------------------------------------------------------
{# retrieve most recent standings from PVoutput server
  $pvurl = "http://pvoutput.org/service/r2/";
  $url = $pvurl."getoutput.jsp?key=".$PV_API_key."&sid=".$PV_sid;
  $content = get $url;
  die "Couldn't get $url" unless defined $content;
  @pvlog = split /,/,$content;
}

#----------------------------------------------------------------
sub updatepv
#----------------------------------------------------------------
{# update pvoutput with new dayvalues
    my ($day,$value,$peaktime, $peakval) = @_;
	my ($xml,$ua,$response);
	$value = int($value + $value/abs($value*2));
	if ($peakval > 0) # no maximum value
	    {$peakval = int($peakval + $peakval/abs($peakval*2));}
	$pvurl = "http://pvoutput.org/service/r2/";
	$url = $pvurl."addoutput.jsp";
		
     $url = $pvurl."addoutput.jsp";
	 $response = `curl -d "data=$day,$value,,$peakval,$peaktime" -H "X-Pvoutput-Apikey:$PV_API_key" -H "X-Pvoutput-SystemId:$PV_sid" $url`;
     my $temp = $response
#     if ($response->is_success) 
#	   { print $response->decoded_content; }  # or whatever
}

#----------------------------------------------------------------
sub makedate
#----------------------------------------------------------------
{
my ( $result,$year,$month,$day,$hour,@items,$date );
my ( $sec, $min, $uur, $dag, $maand, $jaar_off, $wdag, $ydat, $isdst) = localtime;

	#print ("makedate from $log_date\n");
	$log_date =~ s/[-:T+]/ /g;
	@items = split /\s+/, $log_date ;
	$year = $items[0];
	$month = sprintf("%02d",$items[1]);
	$date = sprintf("%02d",$items[2]);

	# stretch is at GMT!
	if ($isdst)  	
	   {$hour   = sprintf("%02d",$items[3]+2);}
	else
	   {$hour   = sprintf("%02d",$items[3]+1);}
	return ( $year." ".$month." ".$date." ".$hour." ");
}

#----------------------------------------------------------------
sub handle_char
#----------------------------------------------------------------
{
  my ($p, $text, %attrs ) = @_;

    if ( $periodend == 0 ) 
	    {
		if ( $current_key eq 'measurement' ) 
		   {my $date = makedate ;
			#printf("$text\n") ;
			push( @data, $date . $text ) ;
		   }
	    $current_key="";
        }
    if ( $producedfound == 0 ) 
	{	if ( $text eq 'electricity_produced' ) 
		{   $producedfound=1;
		    $periodend=0;
	    }
    }

}

#----------------------------------------------------------------
sub handle_end
#----------------------------------------------------------------
{
  my ($p, $elmt ) = @_;
  if ( $elmt eq 'period' ) 
     {#printf("Period end found\n");
	  $periodend=1;
     }
	 
if ($periodend)
    { # process read records
     @new = sort  @data ;	 
	 if ($pvlog_enabled) 
	    {getpvlog();}
     makefile();
    }
}

#----------------------------------------------------------------
sub handle_start()
#----------------------------------------------------------------
{
  my ($p, $elmt, %attrs ) = @_;
  $current_key = $elmt ;
	# get the log_date attribute
	if ( $elmt eq 'measurement' ) 
	   {
		if( %attrs ) 
			{while( my( $key, $value ) = each( %attrs )) 
				{if ( $key eq 'log_date' ) 
					{$log_date = $value ;}
		        }
			}
		}
}

#----------------------------------------------------------------
sub makefile()
#----------------------------------------------------------------
{
# write a file-line for each parsed line
open (HOURFILE, "+>>$outfile_hours") || die "open hourfile:$!";
open (DAYFILE , "+>>$outfile_days") ||  die "open dayfile:$!";

my ($temp, $dayline,$prvday, $peakval, $peaktime, $last_written_hour, $last_written_date);
my ($xmltime,$xmldate,$xmlvalue);
# initial values
$peaktime = '00:00';
$peakval  = '0';
$last_written_hour = "2010010100:00";
$last_written_date = "20100101";
	 
$prvday = "20100101";
$dayoutput=0;

$temp = `tail -1 $outfile_hours`;
	my @temp = split /$separator/,$temp ;
	if  ($temp[0]) 
	    {#already values in file
         $last_written_hour = $temp[0].$temp[1];
		 $last_written_hour =~ s/-//g;
		}
$temp = `tail -1 $outfile_days`;
	@temp = split /$separator/,$temp ;
	if  ($temp[0]) 
	    {#already values in file
         $last_written_date = $temp[0];
		 $last_written_date =~ s/-//g;
		}
	foreach (@new)
	{
		# make an output line of the data
		my @xmlrecord = split /\s+/,$_ ;
        $xmldate  = $xmlrecord[0].$xmlrecord[1].$xmlrecord[2];
		$xmltime  = $xmlrecord[3].":00";
		$xmlvalue = $xmlrecord[4];
#       $xmldatetime = $xmldate.$xmltime;
#       my $xmldatenum  = $xmlrecord[0].$xmlrecord[1].$xmlrecord[2];
#		if ( not $prvday) 
#           { # set prvday to first read record if not defined
#		    $prvday = $xmlrecord[0].$xmlrecord[1].$xmlrecord[2];
#		   }
		if ($prvday lt $xmldate) 
		   { # reading new day, reset daytotal
			if ($last_written_date lt $prvday)
			    { # previous day has not been written to file
  			     $dayline = substr($prvday,0,4)."-".substr($prvday,4,2)."-".substr($prvday,6,2).$separator.$dayoutput."\r\n" ;				
#  			     $dayline = $xmlrecord[0]."-".$xmlrecord[1]."-".$xmlrecord[2].$separator.$dayoutput."\r\n" ;
	             print (DAYFILE $dayline);
				 $last_written_date = $prvday;
				}   
		   if (($pvlog_enabled) && ($pvlog[0] <= $prvday)  && $dayoutput > 0)
		       {updatepv($prvday,$dayoutput,$peaktime,$peakval);}
		   $dayoutput= 0;
		   $peakval  = 0;
		   $peaktime = 0;
		   $prvday   = $xmldate;
		   }
		$dayoutput = $dayoutput + $xmlvalue;
        if ($peakval < $xmlvalue) 
               { # new maximum
			    $peakval  = $xmlvalue;
			    $peaktime = $xmltime;
               }				
		if ($xmldate.$xmltime gt $last_written_hour)
		   { # need to write this entry ?
			my $line = $xmlrecord[0]."-".$xmlrecord[1]."-".$xmlrecord[2].$separator.$xmltime.$separator.$xmlvalue."\r\n" ;
			print (HOURFILE $line);
			$last_written_hour = $xmldate.$xmltime;
		   }	
	}
	if (($pvlog_enabled) && ($pvlog[0] <= $xmldate)  && $dayoutput > 0)
		{updatepv($xmldate,$dayoutput,$peaktime,$peakval);}
		
close (HOURFILE);
close (DAYFILE);
exit;
}
#----------------------------------------------------------------




